#include "Vram.h"
#include "Chars.h"

extern const byte[] MonoPattern, ColorPattern;

static const byte[] PatternColorTable = {
    34,3, // Ascii Knife
    1,2, // Wall
    8,3, // Goal Bang
    4,3, // M
    4,2, // A
    4,1, // Z
    4,3, // Y
    4,3, // Remain
    0xff
};

void InitVram()
{
    {
        byte pattern;
        ptr<byte> pSource, pPattern;
        pattern = 0;
        pSource = PatternColorTable;
        pPattern = MonoPattern;
        while (pSource[0] != 0xff) {
            byte count, color;
            count = *pSource; ++pSource;
            color = *pSource; ++pSource;
            SetPatternMono(pPattern, pattern, color, count);
            pattern += count;
            pPattern += ((word)count) << 2;
        }
    }
    SetPatternColor(ColorPattern, Char_Chaser, 4 * 2);
    InitManPattern();
}


ptr<byte> Put2(ptr<byte> pVram, byte c)
{
    repeat (2) {
        repeat (2) {
            *pVram = c; ++pVram;
            ++c;
        }
        pVram += VramRowSize - 2 * VramStep;
    }
    return pVram + 2 * VramStep - VramRowSize * 2;
}


ptr<byte> Erase2(ptr<byte> pVram)
{
    repeat (2) {
        repeat (2) {
            *pVram = Char_Space; ++pVram;
        }
        pVram += VramRowSize - 2 * VramStep;
    }
    return pVram + 2 * VramStep - VramRowSize * 2;
}
